import 'package:equatable/equatable.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:snaxdart_models/v1.dart';

part 'wallet.g.dart';

@JsonSerializable()
class Wallet extends Equatable {
  @JsonKey(name: 'public_key')
  final String publicKey;

  @JsonKey(name: 'account')
  final WalletAccount account;

  @JsonKey(name: 'logged')
  final bool logged;

  @JsonKey(name: 'outdated')
  final bool outdated;

  Wallet(
      {this.publicKey,
      this.account,
      this.logged = false,
      this.outdated = false})
      : super();

  Wallet.initialState()
      : publicKey = null,
        account = null,
        logged = false,
        outdated = false;

  Wallet copyWith(
      {String publicKey, WalletAccount account, bool logged, bool outdated}) {
    return Wallet(
        publicKey: publicKey ?? this.publicKey,
        account: account ?? this.account,
        logged: logged ?? this.logged,
        outdated: outdated ?? this.outdated);
  }

  Wallet resetAccount() {
    return Wallet(
        account: null,
        publicKey: this.publicKey,
        logged: this.logged,
        outdated: this.outdated);
  }

  factory Wallet.fromJson(Map<String, dynamic> json) => _$WalletFromJson(json);

  Map<String, dynamic> toJson() => _$WalletToJson(this);

  @override
  String toString() => this.toJson().toString();
}
